Index: /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java
===================================================================
--- /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 24051)
+++ /main/trunk/greenstone3/src/java/org/greenstone/gsdl3/LibraryServlet.java	(revision 24052)
@@ -15,7 +15,13 @@
 import java.util.ArrayList;
 import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
 import java.io.File;
+import java.lang.reflect.Type;
 import java.util.Hashtable;
 import org.apache.log4j.*;
+
+import com.google.gson.Gson;
+import com.google.gson.reflect.TypeToken;
 
 // Apache Commons
@@ -560,18 +566,22 @@
 		
 		//Add custom HTTP headers if requested
-		String httpHeaders = StringEscapeUtils.unescapeHtml4(request.getParameter(GSParams.HTTPHEADERFIELDS));
-		if (httpHeaders!=null && !httpHeaders.equals ("")) {
-			String[] headerParams = StringUtils.split(httpHeaders, "&");
-			
-			for(int j = 0; j < headerParams.length; j++)
+		Gson gson = new Gson();
+		Type type = new TypeToken<List<Map<String,String>>>() {}.getType();
+		List<Map<String,String>> httpHeaders = gson.fromJson(request.getParameter(GSParams.HTTPHEADERFIELDS), type);
+		if (httpHeaders != null && httpHeaders.size() > 0) {
+			
+			for(int j = 0; j < httpHeaders.size(); j++)
 			{
-				int index = StringUtils.indexOf(headerParams[j], "=");
+				Map nameValueMap = (Map)httpHeaders.get(j);
+				String name = (String)nameValueMap.get("name");
+				String value = (String)nameValueMap.get("value");
 				
-				if(index != -1)
+				System.err.println("SETTING HEADER " + name + " = " + value);
+				
+				if(name != null && value != null)
 				{
-					response.setHeader(StringUtils.substring(headerParams[j], 0, index), StringUtils.substring(headerParams[j], index+1));
-				}
-			}
-			
+					response.setHeader(name, value);
+				}
+			}
 		}
 		
@@ -689,4 +699,3 @@
 		
 	}
-
 }
Index: /main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 24051)
+++ /main/trunk/greenstone3/web/WEB-INF/classes/interface_default.properties	(revision 24052)
@@ -66,4 +66,8 @@
 query.to=to
 query.of=of
+
+#query.the_term=The term
+#query.common_word=is too common and has been excluded from the search
+query.common=The following terms are too common and have been excluded from the search:
 
 ##################
Index: /main/trunk/greenstone3/web/interfaces/oran/js/berrybasket/berrybasket.js
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/js/berrybasket/berrybasket.js	(revision 24051)
+++ /main/trunk/greenstone3/web/interfaces/oran/js/berrybasket/berrybasket.js	(revision 24052)
@@ -20,5 +20,5 @@
 	
 	var request_type = "GET";
-	var url = "?a=pr&rt=r&ro=1&s=ItemNum&o=XML&hhf=Cache-Control%3Dno-cache&c=";
+	var url = "?a=pr&rt=r&ro=1&s=ItemNum&o=XML&hhf=[{\"name\":\"Cache-Control\", \"value\":\"no-cache\"}]&c=";
 
 	var responseSuccess = function(o){
@@ -293,5 +293,5 @@
 function addBerry(el){
 	alert("ADDING");
-	var addurl = "?a=pr&rt=r&ro=1&s=AddItem&c=&s1.id=2&o=XML&hhf=Cache-Control%3Dno-cache&s1.item=" + el.id;
+	var addurl = "?a=pr&rt=r&ro=1&s=AddItem&c=&s1.id=2&o=XML&hhf=[{\"name\":\"Cache-Control\", \"value\":\"no-cache\"}]&s1.item=" + el.id;
 
 	var addSuccess = function(o){
Index: /main/trunk/greenstone3/web/interfaces/oran/js/berrybasket/ygDDPlayer.js
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/js/berrybasket/ygDDPlayer.js	(revision 24051)
+++ /main/trunk/greenstone3/web/interfaces/oran/js/berrybasket/ygDDPlayer.js	(revision 24052)
@@ -124,6 +124,6 @@
 
 var request_type = "GET";
-var addurlPath ="?a=pr&rt=r&ro=1&s=AddItem&c=&s1.id=2&o=XML&hhf=Cache-Control%3Dno-cache&s1.item=";
-var delurlPath ="?a=pr&rt=r&ro=1&s=DeleteItem&c=&o=XML&hhf=Cache-Control%3Dno-cache&s1.item=";
+var addurlPath ="?a=pr&rt=r&ro=1&s=AddItem&c=&s1.id=2&o=XML&hhf=[{\"name\":\"Cache-Control\", \"value\":\"no-cache\"}]&s1.item=";
+var delurlPath ="?a=pr&rt=r&ro=1&s=DeleteItem&c=&o=XML&hhf=[{\"name\":\"Cache-Control\", \"value\":\"no-cache\"}]&s1.item=";
 var postdata = null;
 
Index: /main/trunk/greenstone3/web/interfaces/oran/style/berry.css
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/style/berry.css	(revision 24051)
+++ /main/trunk/greenstone3/web/interfaces/oran/style/berry.css	(revision 24052)
@@ -2,9 +2,6 @@
 	min-height: 22px;
 	padding: 5px;
-	/*margin: 0 0 1em 0;*/
-	/* background: #E0F0E0 url("../images/berrybasket.png") scroll no-repeat 0 0; */
 	background: transparent url("../images/kete2.png") scroll repeat 0 0;
 	z-index:10;
-	/*cursor: pointer;*/
 	font-size: 80%;
 	min-height: 2em;
Index: /main/trunk/greenstone3/web/interfaces/oran/style/core.css
===================================================================
--- /main/trunk/greenstone3/web/interfaces/oran/style/core.css	(revision 24051)
+++ /main/trunk/greenstone3/web/interfaces/oran/style/core.css	(revision 24052)
@@ -330,5 +330,4 @@
 	float: right;
 	margin: 0;
-	background: transparent url('../images/tab-right.gif') no-repeat scroll 100% -50px;
 	padding: 0 2px 0 0;
 }